{% extends "base.html" %}
{% block title %}Course {{ course.name }}{% endblock %}
{% set max_page = len(materials) %}
{% block head %}
<script>
  let currentPage = 1;
  let maxPageNumber = {{ max_page }};
  let minPageNumber = 1;
  window.onload = function() {
      updatePage(1);
  };
  
  function prevPage() {
      if (checkPage(currentPage - 1)) {
          currentPage --;
          updatePage(currentPage)
      }
  };
  
  function nextPage() {
      if (checkPage(currentPage + 1)) {
          currentPage ++;
          updatePage(currentPage)
      }
  };
  
  function checkPage(pageNumber) {
      if (pageNumber > maxPageNumber || pageNumber < minPageNumber) {
          return false;
      } else {
          return true;
      }
  };
  
  function updatePage(pageNumber) {
      console.log('updatePage');
      if (checkPage(pageNumber)) {
          document.getElementById('page-name').innerText = 'Page ' + pageNumber.toString();
          document.getElementById('page-num').innerText = pageNumber;
          let subpages = document.getElementsByClassName('page-any');
          let subpage;
          for (i = 0; i < subpages.length; i++) {
              subpage = subpages[i];
              subpage.style.display = 'none';
          }
          subpages = document.getElementsByClassName('page-' + pageNumber.toString());
          for (i = 0; i < subpages.length; i++) {
              subpage = subpages[i];
              subpage.style.display = 'block';
          }
          if (pageNumber === minPageNumber) {
              document.getElementById('prev-page').style.display = 'none';
              document.getElementById('next-page').style.display = 'block';
          } else if (pageNumber === maxPageNumber) {
              document.getElementById('prev-page').style.display = 'block';
              document.getElementById('next-page').style.display = 'none';
          }
          return true;
      } else {
          return false;
      }
  };
</script>
{% endblock %}
{% block navbar %}
  <a class="w3-bar-item w3-btn w3-round-large w3-btn" style="transition: 0.5s; margin: 0.5em;" href="/courses">
    <span class="material-icons" style="font-size: 1em;">school</span>
    View All Courses
  </a>
{% endblock %}
{% block content %}
<h1>{{ course.name }} - Level {{ int(level) + 1 }}</h1>
<div class="w3-bar w3-border w3-round-large w3-margin-bottom">
  <style>
    @keyframes hideOneSec {
      0%   {opacity: 0.0; display: none;}
      50%  {opacity: 0.0; display: block;}
      100% {opacity: 1.0; display: block;}
    }
  </style>
  <a href="#" class="w3-bar-item w3-button w3-left" id="prev-page" style="transition: 0.5s; animation-fill-mode: forwards; animation-name: hideOneSec; animation-duration: 2s;" onclick="prevPage();">
    <span class="material-icons">arrow_back</span>
  </a>
  <span class="w3-bar-item">
    Page <span id="page-num">1</span>/{{ max_page }} - <span id="page-name">Loading...</span>
  </span>
  <a href="#" class="w3-bar-item w3-button w3-right" id="next-page" style="transition: 0.5s; animation-fill-mode: forwards; animation-name: hideOneSec; animation-duration: 2s;" onclick="nextPage();">
    <span class="material-icons">arrow_forward</span>
  </a>
</div>
{% for i in range_len_materials %}
{% set material = materials[i] %}
<div class="w3-border w3-round-large w3-padding w3-margin-bottom page-{{ material.i + 1 }} page-any" id="page-{{ material.i + 1 }}-{{ material.j + 1 }}">
  <!--page: {{ material.i + 1 }}-->
  <!--subpage: {{ material.j + 1 }}-->
  <!--datatype: {{ material.data_type }}-->
  {% if material.data_type == 'rawurl' %}
  {% set material_data_type_icon = 'link' %}
  <span class="material-icons">{{ material_data_type_icon }}</span><br />
  <iframe frameborder="0" class="w3-round-large w3-card-4" src="{{ material.data }}" allowfullscreen>
    <div class="w3-panel w3-card-4 w3-margin-top w3-round-large w3-light-grey w3-leftbar w3-animate-opacity w3-border-red w3-center" style="transition: 0.5s; width: fit-content;">
      <p>
        <span class="material-icons">error</span>
        Please use a browser instance that supports and allows <span class="w3-codespan">iframe</span>s.
      </p>
    </div>
  </iframe>
  {% elif material.data_type == 'url' %}
  {% set material_data_type_icon = 'link' %}
  {% set url_data = json.loads(material.data) %}
  <span class="material-icons">{{ material_data_type_icon }}</span><br />
  <iframe frameborder="0" class="w3-round-large w3-card-4" src="{{ url_data['url'] }}" allowfullscreen>
    <div class="w3-panel w3-card-4 w3-margin-top w3-round-large w3-light-grey w3-leftbar w3-animate-opacity w3-border-red w3-center" style="transition: 0.5s; width: fit-content;">
      <p>
        <span class="material-icons">error</span>
        Please use a browser instance that supports and allows <span class="w3-codespan">iframe</span>s.
      </p>
    </div>
  </iframe>
  {% elif material.data_type == 'text' %}
  {% set material_data_type_icon = 'article' %}
  {% set text_data = json.loads(material.data) %}
  <span class="material-icons">{{ material_data_type_icon }}</span><br />
  <div class="w3-container w3-card-4 w3-round-large w3-padding w3-margin-bottom">
    {{ text_data['content'] }}
  </div>
  {% elif material.data_type == 'rawtext' %}
  {% set material_data_type_icon = 'article' %}
  <span class="material-icons">{{ material_data_type_icon }}</span><br />
  <div class="w3-container w3-card-4 w3-round-large w3-padding w3-margin-bottom">
    {{ material.data }}
  </div>
  {% elif material.data_type == 'image' %}
  {% set material_data_type_icon = 'photo' %}
  {% set text_data = json.loads(material.data) %}
  <span class="material-icons">{{ material_data_type_icon }}</span><br />
  <div class="w3-container w3-card-4 w3-round-large w3-padding w3-margin-bottom">
    <img src="{{ text_data['url'] }}" />
  </div>
  {% elif material.data_type == 'rawimage' %}
  {% set material_data_type_icon = 'photo' %}
  <span class="material-icons">{{ material_data_type_icon }}</span><br />
  <div class="w3-container w3-card-4 w3-round-large w3-padding w3-margin-bottom">
    <img src="{{ material.data }}" />
  </div>
  {% elif material.data_type == 'video' %}
  {% set material_data_type_icon = 'play_circle_filled' %}
  {% set video_data = json.loads(material.data) %}
  <span class="material-icons">{{ material_data_type_icon }}</span><br />
  <video controls class="w3-container w3-card-4 w3-round-large w3-margin-bottom" style="padding: 0">
    {% for source in video_data['sources'] %}
    <source src="{{ source['url'] }}" type="{{ source['type'] }}">
    {% endfor %}
    {% for track in video_data['tracks'] %}
    <track src="{{ source['url'] }}" kind="{{ source['kind'] }}" srclang="{{ source['lang'] }}" label="{{ source['label'] }}">
    {% endfor %}
    <div class="w3-panel w3-card-4 w3-margin-top w3-round-large w3-light-grey w3-leftbar w3-animate-opacity w3-border-red w3-center" style="transition: 0.5s; width: fit-content;">
      <p>
        <span class="material-icons">error</span>
        Please use a browser instance that supports and allows <span class="w3-codespan">video</span>s.
      </p>
    </div>
  </video>
  {% elif material.data_type == 'rawvideo' %}
  {% set material_data_type_icon = 'play_circle_filled' %}
  <span class="material-icons">{{ material_data_type_icon }}</span><br />
  <video controls class="w3-container w3-card-4 w3-round-large w3-margin-bottom" style="padding: 0">
    <source src="{{ material.data }}" type="video/mp4">
    <div class="w3-panel w3-card-4 w3-margin-top w3-round-large w3-light-grey w3-leftbar w3-animate-opacity w3-border-red w3-center" style="transition: 0.5s; width: fit-content;">
      <p>
        <span class="material-icons">error</span>
        Please use a browser instance that supports and allows <span class="w3-codespan">video</span>s.
      </p>
    </div>
  </video>
  {% elif material.data_type == 'question' %}
  {% set material_data_type_icon = 'question_answer' %}
  <span class="material-icons">{{ material_data_type_icon }}</span><br />
  {% set question_data = json.loads(material.data) %}
  <script>
    function showPage{{ material.i + 1 }}Subpage{{ material.j + 1 }}Help() {
        {% if 'help' in question_data.keys() %}
        alert('{{ question_data['help'] }}');
        {% else %}
        alert('No help available.');
        {% endif %}
    };
    // I know the indent width is inconsistent, PyCharm is forcing me to use this
    // (I'm completely 100% blaming this on PyCharm and changing the indent setting was *totally* not an option).
    function checkPage{{ material.i + 1 }}Subpage{{ material.j + 1 }}Radio() {
        let notifyError = document.getElementById("page-{{ material.i + 1 }}-{{ material.j + 1 }}-notify-error");
        let notifyErrorText = document.getElementById("page-{{ material.i + 1 }}-{{ material.j + 1 }}-notify-error-text");
        let notifyOk = document.getElementById("page-{{ material.i + 1 }}-{{ material.j + 1 }}-notify-ok");
        let notifyOkText = document.getElementById("page-{{ material.i + 1 }}-{{ material.j + 1 }}-notify-ok-text");
        const radios = document.getElementsByName("page-{{ material.i + 1 }}-{{ material.j + 1 }}-radio");
        let optionSelected = false;
        let optionCorrect = false;
        const correctOption = {{ question_data['answer'] }};
        // Yes, I know that you can cheat it by reading the `const` above.
        // But, if you are smart enough that you even do this, you'll probably get the answer right anyway.
        // (unless someone was kind enough to showed you how to do this)
        let i = 0;
        while (!optionSelected && i < radios.length) {
            let radio = radios[i]
            if (radio.checked) optionSelected = true;
            if (radio.checked && radio.value.toString() === correctOption.toString()) optionCorrect = true;
            i++;
        }
        if (!optionSelected) {
            notifyOk.style.display = "none";
            notifyErrorText.innerText = "Select an option.";
            notifyError.style.display = "block";
        } else if (!optionCorrect) {
            notifyOk.style.display = "none";
            {% if 'help' in question_data.keys() %}
            notifyErrorText.innerHTML = "Option incorrect. Would you like to <a class=\"w3-text-blue w3-hover-text-deep-purple\" onclick=\"showPage{{ material.i + 1 }}Subpage{{ material.j + 1 }}Help()\" style=\"transition: 0.5s; text-decoration: none;\">have some help</a>?";
            {% else %}
            notifyErrorText.innerText = "Option incorrect.";
            {% endif %}
            notifyError.style.display = "block";
        } else if (optionCorrect) {
            for (let i = 0; i < radios.length; i ++) {
                let radio = radios[i]
                radio.disabled = true;
            }
            document.getElementById("page-{{ material.i + 1 }}-{{ material.j + 1 }}-iframe").src =
                "{{ url_for('courses_submit', course_uid=course.course_uid, level=level, page=material.i, subpage=material.j, type='question', data=1) | safe }}"
            notifyError.style.display = "none";
            notifyOkText.innerText = "Option correct.";
            notifyOk.style.display = "block";
        } else {
            // If this happens, there either is
            // 1. a logical error, or
            // 2. a JS glitch.
            notifyErrorText.innerText = "Internal JavaScript error occurred.";
            notifyError.style.display = "block";
            notifyOk.style.display = "none";
        }
    };
  </script>
  <noscript>
    <div class="w3-panel w3-card-4 w3-margin-top w3-round-large w3-light-grey w3-leftbar w3-animate-opacity w3-border-red w3-center" style="transition: 0.5s; width: fit-content;">
      <p>
        <span class="material-icons">error</span>
        Please use a browser instance that supports and allows JavaScript. JavaScript is required for the questions to be validated.
      </p>
    </div>
  </noscript>
  <iframe id="page-{{ material.i + 1 }}-{{ material.j + 1 }}-iframe" frameborder="0" style="max-width: 1px; max-height: 1px; padding: 0; margin: 0; background-color: transparent;" src="{{ url_for('blank') }}"></iframe>
  {% if len(question_data["choices"]) == 5 %}
  <h2>{{ question_data["question"] }}</h2>
  {% for choice in question_data["choices"] %}
  <input
    class="w3-radio"
    type="radio"
    name="page-{{ material.i + 1 }}-{{ material.j + 1 }}-radio"
    value="{{ question_data['choices'].index(choice) }}">
  <label>{{ choice }}</label><br />
  {% endfor %}
  <div
    class="w3-animate-zoom w3-panel w3-card-4 w3-margin-top w3-round-large w3-light-grey w3-leftbar w3-animate-opacity w3-border-red w3-center"
    style="transition: 0.5s; width: fit-content; display: none;"
    id="page-{{ material.i + 1 }}-{{ material.j + 1 }}-notify-error"
  >
    <p>
      <span class="material-icons">error</span>
      <span id="page-{{ material.i + 1 }}-{{ material.j + 1 }}-notify-error-text">
        Internal error occured.
      </span>
    </p>
  </div>
  <div
    class="w3-animate-zoom w3-panel w3-card-4 w3-margin-top w3-round-large w3-light-grey w3-leftbar w3-animate-opacity w3-border-green w3-center"
    style="transition: 0.5s; width: fit-content; display: none;"
    id="page-{{ material.i + 1 }}-{{ material.j + 1 }}-notify-ok"
  >
    <p>
      <span class="material-icons">check</span>
      <span id="page-{{ material.i + 1 }}-{{ material.j + 1 }}-notify-ok-text">
        Internal error occured.
      </span>
    </p>
  </div>
  <button
    class="w3-bar-item w3-btn w3-round-large w3-margin w3-border w3-border-green"
    style="transition: 0.5s;"
    onclick="checkPage{{ material.i + 1 }}Subpage{{ material.j + 1 }}Radio()"
  >
    <span class="material-icons" style="font-size: 1em;">check</span>
    Check Answer
  </button>
  {% else %}
  <div class="w3-panel w3-card-4 w3-margin-top w3-round-large w3-light-grey w3-leftbar w3-animate-opacity w3-border-red w3-center" style="transition: 0.5s; width: fit-content;">
    <p>
      <span class="material-icons">error</span>
      This question is invalid. Either the data is corrupt, or it was not inputted correctly.
      Please contact an/the administrator. Choice length (<span class="w3-codespan">{{ len(question_data["choices"]) }}</span>)
      is not <span class="w3-codespan">5</span>.
    </p>
  </div>
  {% endif %}
  {% else %}
  {% set material_data_type_icon = 'error' %}
  <span class="material-icons">{{ material_data_type_icon }}</span><br />
  <div class="w3-panel w3-card-4 w3-margin-top w3-round-large w3-light-grey w3-leftbar w3-animate-opacity w3-border-red w3-center" style="transition: 0.5s; width: fit-content;">
    <p>
      <span class="material-icons">error</span>
      This material subpage is invalid. Either the data is corrupt, or it was not inputted correctly.
      Please contact an/the administrator. <br />Raw data:
      <p class="w3-code">{{ material.data }}</p>
    </p>
  </div>
  {% endif %}
  {% set max_page = material.i + 1 %}
</div>
{% endfor %}
{% endblock %}